/*
Copyright (C) 2004 Relja Arandjelovic, see COPYING

    This file is part of RA Pai Gaw Poker.

    RA Pai Gaw Poker is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "dealer.h"


void radi_PetKeceva(Karta r[]){
  r[6].vred=KEC;
  // ako par kraljeva stavi napred, a pet keceva nazad
  if (r[4].vred==KRALJ && r[5].vred==KRALJ) // posto sort i 4 Keca na poc
      raz(r[4],r[6]); // 5 vec na mestu
  // inace stavi par keceva napred
  else 
    raz(r[3],r[5]); 
}


void straight(Karta r[], Karta res[], int &postavljen){
  int poslednji,i,brodst,t;
  Karta tres[2];

  for (poslednji=6; poslednji>=4; poslednji--){ // koj cu da uzmem da je poslednji
    brodst=0;
    for (i=poslednji-1;i>=poslednji-brodst-4 && brodst<=poslednji-6+2;i--) {
      // brodst? valjda treba.. ili +?
      if (r[i].vred==r[i+1].vred) brodst++; else
	if (r[i].vred>r[i+1].vred+1) brodst=20;
    }
    //    if (brodst<=poslednji-6+2) break;
    //  }

    if (brodst<=poslednji-6+2){
      // nasao
      t=0;
      for (i=0;t<2 && i<poslednji-brodst-4;i++) tres[t++]=r[i];
      for (i=poslednji+1;t<2 && i<7;i++) tres[t++]=r[i];
      for (i=poslednji-brodst-4;t<2;i++) if (r[i].vred==r[i+1].vred)
	tres[t++]=r[i];

      if (postavljen==0 || Uporedi2sa2(tres,res)==1){
	res[0]=tres[0]; res[1]=tres[1];
	postavljen=1;
      }

    }
  } //dodat
}

int radi_flstr(Karta r[]){
  int postavljen=0,i=0,brodst,boja,t; //,str
  Karta res[2];

  // flush

  for (boja=1;boja<5;boja++){ // svaku boju gledam da najvece karte
    brodst=0;
    for (i=6;i>=0 && brodst<=2;i--) if (r[i].boja!=boja && r[i].boja!=0) brodst++;
    if (brodst<=2){ // nasao flush
      postavljen=1;
      // trazi najvece 2 karte koje nisu u flush-u
      if (brodst==0) {res[0]=r[0]; res[1]=r[1];} // 7moclani flush
      else
      if (brodst==1) { //6oclani flush

	// prvo, sigurno ukljucujemo onaj koji odstupa
	for (i=0;i<7 && (r[i].boja==boja || r[i].boja==0);i++);
	res[0]=r[i];
	// probaj da nadjes par ( ne mora dzoker jer ce njega posle jer najveci
	for (i=0;i<7;i++) if (r[i].vred==res[0].vred && r[i].boja==boja) break;
	// nema para, nadji najveci
	if (i==7) for (i=0;r[i].boja!=boja && r[i].boja!=0;i++);

	res[1]=r[i];

      } else // potoclani flush - ako postoji dzoker on je u njemu
	{
	  t=0; i=0;
	  // nadji ostale clanove - ako nema dzokera 2 clana, ako ima 1
	  while (t<2){
	    for (;r[i].boja==boja || r[i].boja==0;i++);
	    res[t++]=r[i++];
	  }
	}

    }
  }

  /**/
  // straight
  if (r[0].boja==0){
    t=0;
    for (r[t].vred=KEC-1; r[t].vred>=1; r[t].vred--) {
      while (t<6 && r[t].vred<=r[t+1].vred){
	raz(r[t],r[t+1]); t++; // kad mu menjam vrednost sortiranje se remeti
	// (dva reda gore) <= jer hocu da dzoker bude na kraju istih karata
	// da bi radio primer: 0_0 10_1 9_2 8_3 8_4 7_3 6_4
	// tu ce dzoker=8 a prave osmice ispred
      }
      straight(r,res,postavljen);
    }
    r[6].vred=KEC; // za posle ovog bloka, sigurno stigao na 6. mesto jer bio 1
    sortRuku(r,7);
  }
   straight(r,res,postavljen);
  /**/
   // posle straight provere
   // dzoker je postavljen na Kec, bez obzira da li treba da bude KEC
   // da popuni rupu

  // nadji resenja u ruci pa zameni tako da budu na 6. i 7. mestu
  if (postavljen){
    sortRuku(res,2);
    t=0;
    for (i=0;t<2;)
      if ((res[t].vred==r[i].vred || res[t].boja==0) && res[t].boja==r[i].boja) {
	raz(r[i],r[6-t]);
	t++;
      } else i++;
  }


  return postavljen;
}

void nadjinivopara(int &nivopara, const Karta &k){
  if (k.vred==KEC) nivopara=KEC; else
    if (k.vred>=11) nivopara=3; else
      if (k.vred>=7) nivopara=2; else nivopara=1;  
}

void HouseWay_pravi(Karta r[]){ // vraca prvih 5 + druge 2 karte
  int i,j,t,temp,temp2,dzoker=0;
  int nivopara1,nivopara2;
  //  int fl,str;

  sortRuku(r,7);

  if (r[6].vred==0) dzoker=1;

  if (dzoker && PetKeceva(r,7)) {radi_PetKeceva(r); return;}
  // radi_flstr(r);

                 // pazi da li se pozicija promenila
  if (dzoker) {r[6].vred=KEC; sortRuku(r,7);}

  t=0;
  for (i=0;i<6;i++)
    for (j=i+1; j<7 && r[i].vred==r[j].vred ; j++) t++;

  /*
t=
9 - poker+triling
7 - poker+par
6 - poker, triling+triling
5 - full+par
4 - full
3 - triling, 3*par
2 - 2*par
1 - par
   */

  switch (t){
  case 9:   // igraj par iz trilinga napred
    if (r[0].vred==r[3].vred) temp=4; else temp=0;

    raz(r[temp],r[6]); raz(r[temp+1],r[5]); // vazan ovaj redosled - SVUDA!!
    return;
    break;

  case 7:   // par napred (ne iz pokera)
    temp2=index(r,4,0,7);
    temp=index(r,2,0,temp2);
    if (temp==-1) temp=index(r,2,temp2+4,7);

    raz(r[temp],r[6]); raz(r[temp+1],r[5]);
    return;
    break;

  case 6:
    temp=index(r,4,0,7);
    if (temp!=-1){ // poker

      if (r[temp].vred<=6){ // 2-6
	if (temp==0) raz(r[4],r[6]); else
	  if (temp==1) raz(r[0],r[6]); else {raz(r[0],r[6]); raz(r[1],r[5]);}
      } else
	if (r[temp].vred==KEC){ // kec
	  raz(r[0],r[6]); raz(r[1],r[5]);
	} else {
	  if ( (r[temp].vred<=10 && r[0].vred>=KRALJ) ||
	       (r[temp].vred>=11 && r[0].vred==KEC) )
	    {
	      raz(r[0],r[6]);
	      if (temp>1) raz(r[1],r[5]);
	    } else { // podeli
	      raz(r[temp],r[6]); raz(r[temp+1],r[5]);
	    }
	}

    } else { // 2*triling - napred veci (tj prvi) par
      temp=index(r,3,0,7);
      raz(r[temp],r[6]); raz(r[temp+1],r[5]);
    }

    return;
    break;

  case 5: case 4: // vazi i za straight/flush

    if (t==4 && r[0].vred==KEC && r[1].vred==KRALJ &&
	r[5].vred==2 && r[6].vred==2 && r[4].vred!=2){
      // ako par dvojki i postoji KEC i KRALJ stavi KEC+KRALJ napred
      // (r[4].vred!=2 garantuje da dvojke nisu triling...
      raz(r[0],r[5]); raz(r[1],r[6]);
    } else {
      // najveci (tj prvi) par napred (radi i za obican full tj t=4)
      temp=index(r,2,0,7);
      temp2=index(r,3,0,7);
      if (temp==temp2) temp=index(r,2,temp2+2,7); // ako nasao triling umesto par
      raz(r[temp],r[6]); raz(r[temp+1],r[5]);
    }

    return;
    break;

  case 2: // vazi i za straight/flush
    temp=index(r,2,0,7); nadjinivopara(nivopara1,r[temp]);
    temp2=index(r,2,temp+2,7); nadjinivopara(nivopara2,r[temp2]);
    // podeli
    if (
	(nivopara2==1 && nivopara1<=2 && r[0].vred<KRALJ) ||
	(((nivopara2==1 && nivopara1==3) || (nivopara2==2 && nivopara1==2))
	 && r[0].vred<KEC) ||
	(nivopara2==2 && nivopara1==3) ||
	(nivopara2==3 && nivopara1==3) ||
	(nivopara1==KEC)
	) {
      raz(r[temp2],r[6]); raz(r[temp2+1],r[5]);
    } else {
      raz(r[0],r[6]); // svi imaju prvu kartu za uslov
      // nadji sledecu
      i=1;  if (temp==1) { i=3; if (temp2==3) i=5; }
      raz(r[i],r[5]);
    }

    return;
    break;

  case 3:
    if (index(r,3,0,7)==-1){ // 3 para a ne triling
      // najveci (prvi) par napred
      temp=index(r,2,0,7);
      raz(r[temp],r[6]); raz(r[temp+1],r[5]);
      return;
    }
    break;

  }

  // sad flush
  if (radi_flstr(r)) return;
  
  switch (t){
  case 0: // najveca nazad, sledece 2 napred
    raz(r[1],r[6]);
    raz(r[2],r[5]);
    return;
    break;
  case 1: // 2 najvece (neracunajuci par) napred
    temp=index(r,2,0,7);
    if (temp==0){ raz(r[2],r[6]); raz(r[3],r[5]); }
    else if (temp==1){ raz(r[0],r[6]); raz(r[3],r[5]); }
    else { raz(r[0],r[6]); raz(r[1],r[5]); }

    return;
    break;
  case 3: // ako kecevi jednog napred, ako ne zadrzi
    temp=index(r,3,0,7);
    if (r[temp].vred==KEC){ raz(r[0],r[6]); raz(r[3],r[5]); } else
      {
	if (temp==0){ raz(r[3],r[6]); raz(r[4],r[5]); }
	else if (temp==1){ raz(r[0],r[6]); raz(r[4],r[5]); }
	else { raz(r[0],r[6]); raz(r[1],r[5]); }
      }
    return;
    break;
  }

}

void HouseWay(Karta r[]){
  HouseWay_pravi(r);
  sortRuku(r,5);
  sortRuku(r+5,2);
}

//----------------------------------------------------------

void DEALER_funkzaproveru1(){
  int i,j,n;
  Karta ka[100][7];

  ifstream fin("in_d.txt");
  fin>>n;

  for (i=0;i<n;i++)
    for (j=0;j<7;j++) {
      fin>>ka[i][j].vred;
      fin>>ka[i][j].boja;}

  fin.close();

  for (i=0;i<n;i++) {
    HouseWay(ka[i]); cout<<i<<"\t";
    for (j=0;j<7;j++){
      if (ka[i][j].boja==0) cout<<"*"; else cout<<" ";
      if (ka[i][j].vred<10) cout<<" ";
      cout<<ka[i][j].vred<<" "; if (j==4) cout<<"\t";}
    cout<<endl;
  }
}

void DEALER_funkzaproveru2(){
  int i;
  Karta r[7];

  while (1){

    cout<<"\nCitam:\n";
    for (i=0;i<7;i++) cin>>r[i].vred>>r[i].boja;
    cout<<endl;

    HouseWay(r);

    for (i=0;i<7;i++){
      if (r[i].boja==0) cout<<"*"; else cout<<" ";
      if (r[i].vred<10) cout<<" ";
      cout<<r[i].vred<<"_"<<r[i].boja<<" ";
      if (i==4) cout<<"\t";
    }
  }


}
