/*
Copyright (C) 2004 Relja Arandjelovic, see COPYING

    This file is part of RA Pai Gaw Poker.

    RA Pai Gaw Poker is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "font.h"

void Font::NacrtajRec(SDL_Surface *ekran, SDL_Surface *slika, Uint16 sirina){
  SDL_Rect dest;
  dest.x = X;
  dest.y = Y;
  SDL_BlitSurface(slika, NULL, ekran, &dest);

  PostaviXY(X+sirina,Y);
}

void Font::KojeSlovo(char ch, int &rednibr, int &malo){
  for (rednibr=0; rednibr<N && ch!=Char[1][rednibr]; rednibr++);
  if (rednibr<N) {malo=1; return;}

  for (rednibr=0; rednibr<N && ch!=Char[0][rednibr]; rednibr++);
  if (rednibr<N) {malo=0; return;}

  rednibr=-1; // napisi obicno
}

Uint16 Font::KojKod(char ch){
  int rednibr,malo;
  KojeSlovo(ch,rednibr,malo);
  if (rednibr==-1 || rednibr>=N) return ch;
  return Kod[malo][rednibr];
}

void Font::Napisi(SDL_Surface *ekran, TTF_Font *font, SDL_Color &Fg, SDL_Color &Bg,  char str[], int x_poc, int y_poc, int x_kraj){

  int i,j,l,sirina,visina;
  Uint16 ustr[200];
  SDL_Surface *rec=NULL;

  for (l=0;str[l];l++); // duzina stringa

  PostaviXY(x_poc,y_poc);

  for (i=0;i<l;i++) if (str[i]!=' ') {
    if (str[i]=='\n') NoviRed(font,x_poc); else {

      for (j=i;j<l && str[j]!='\n' && str[j]!=' ';j++)
	ustr[j-i]=KojKod(str[j]);
      ustr[j-i]=' ';
      ustr[j-i+1]=0;

      TTF_SizeUNICODE(font, ustr, &sirina, &visina);
      if (X+sirina>x_kraj) NoviRed(font,x_poc);

      rec=TTF_RenderUNICODE_Shaded(font,ustr,Fg,Bg);
      NacrtajRec(ekran,rec,sirina);

      i=j-1; // jer i++

    }
  }

  SDL_FreeSurface(rec);

}

void Font::Inicijalizuj(char fontpath[], char font[]){
 char path[500];
 FILE *f;
 int i;

 sprintf(path,"%sFont/%s.txt",fontpath,font);
 f=fopen(path,"r");

 fscanf(f,"%d\n", &N);
 for(i=0;i<N;i++)
   fscanf(f,"%c%c %d %d\n",&Char[0][i],&Char[1][i],&Kod[0][i],&Kod[1][i]);

 fclose(f);
}
