/*
Copyright (C) 2004 Relja Arandjelovic, see COPYING

    This file is part of RA Pai Gaw Poker.

    RA Pai Gaw Poker is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "rapaigawpoker.h"

void InicijalizujTekstRezultat(){
  sprintf(Rezultat[SRPSKI][NERESENO],"Nere[eno");
  sprintf(Rezultat[SRPSKI][JA],"Vi ste pobedili");
  sprintf(Rezultat[SRPSKI][DEALER],"Protivnik je pobedio");

  sprintf(Rezultat[ENGLISH][NERESENO],"Push");
  sprintf(Rezultat[ENGLISH][JA],"You win");
  sprintf(Rezultat[ENGLISH][DEALER],"Dealer wins");
}


void CrtajKarte(Karta r[], int n, int poc_x, int poc_y,

		int moguceizabrana, int prikazi){
  int i,dY[7];
  for (i=0;i<n;i++) dY[i]=moguceizabrana*KartaIzabrana[i]*DELTA_Y;

  for (i=0;i<n;i++)
    if (prikazi){
      if (r[i].boja==0)
	NacrtajSliku(karta[ 0 ][ 0 ], ekran,
		     poc_x + i*(SIRINA_KARTE+IZMEDJU_KARATA), poc_y-dY[i]);
      else
	NacrtajSliku(karta[ r[i].boja ][ r[i].vred-1 ], ekran,
		     poc_x + i*(SIRINA_KARTE+IZMEDJU_KARATA), poc_y-dY[i]);
    }
    else // ako dealer-ove karte
    NacrtajSliku(zadnja_strana, ekran,
		 poc_x + i*(SIRINA_KARTE+IZMEDJU_KARATA), poc_y);
}

void CrtajZetone(){
  NacrtajSliku(zeton100,ekran,ZETONI_X,ZETONI_Y);
  NacrtajSliku(zeton25,ekran,ZETONI_X,ZETONI_Y+1*(VISINA_ZETONA+IZMEDJU_ZETONA));
  NacrtajSliku(zeton5,ekran,ZETONI_X,ZETONI_Y+2*(VISINA_ZETONA+IZMEDJU_ZETONA));
  NacrtajSliku(zeton1,ekran,ZETONI_X,ZETONI_Y+3*(VISINA_ZETONA+IZMEDJU_ZETONA));
}

void CrtajUlog(){
  int tUlog=Ulog, ulog_y=ULOG_Y;
  while (tUlog>=100){
    tUlog-=100;
    NacrtajSliku(zeton100,ekran,ULOG_X,ulog_y);
    ulog_y-=DEBLJINA_ZETONA;
  }
  while (tUlog>=25){
    tUlog-=25;
    NacrtajSliku(zeton25,ekran,ULOG_X,ulog_y);
    ulog_y-=DEBLJINA_ZETONA;
  }
  while (tUlog>=5){
    tUlog-=5;
    NacrtajSliku(zeton5,ekran,ULOG_X,ulog_y);
    ulog_y-=DEBLJINA_ZETONA;
  }
  while (tUlog>=1){
    tUlog-=1;
    NacrtajSliku(zeton1,ekran,ULOG_X,ulog_y);
    ulog_y-=DEBLJINA_ZETONA;
  }
}

void CrtajDugmice(){
  NacrtajSliku(dHelp[Jezik],ekran,DUGME_POC_X,DUGME_POC_Y);
  NacrtajSliku(dNext[Jezik],ekran,DUGME_POC_X,DUGME_POC_Y+2*(DUGME_IZMEDJU+DUGME_VISINA));
  NacrtajSliku(dHouseWay[Jezik],ekran,DUGME_POC_X,DUGME_POC_Y+3*(DUGME_IZMEDJU+DUGME_VISINA));

  if (StanjeHelp){
    NacrtajSliku(dRules[Jezik],ekran,DUGME_POC_X-(DUGME_SIRINA+2*DUGME_IZMEDJU),DUGME_POC_Y);
    NacrtajSliku(dHouseWay[Jezik],ekran,DUGME_POC_X-(DUGME_SIRINA+2*DUGME_IZMEDJU),DUGME_POC_Y+1*(DUGME_IZMEDJU+DUGME_VISINA));
    NacrtajSliku(dInterface[Jezik],ekran,DUGME_POC_X-(DUGME_SIRINA+2*DUGME_IZMEDJU),DUGME_POC_Y+2*(DUGME_IZMEDJU+DUGME_VISINA));
  }
}

void CrtajZastave(){
  int i;
  for (i=0;i<BRJEZ;i++)
    NacrtajSliku(zastava[i],ekran,ZASTAVA_X,ZASTAVA_Y+i*(ZASTAVA_VISINA+ZASTAVA_IZMEDJU));
}

void IspisiHelp(char Help[],char Rules[],char HouseWay[],char Interface[]){
  switch (StanjeHelp){
  case HELP:
    FJezik[Jezik].Napisi(ekran,deffont,Crna,Bg,Help,10,10,DUGME_POC_X-(DUGME_SIRINA+2*DUGME_IZMEDJU)); break;
  case RULES:
    FJezik[Jezik].Napisi(ekran,deffont,Crna,Bg,Rules,10,10,DUGME_POC_X-(DUGME_SIRINA+2*DUGME_IZMEDJU)); break;
  case HOUSEWAY:
    FJezik[Jezik].Napisi(ekran,deffont,Crna,Bg,HouseWay,10,10,DUGME_POC_X-(DUGME_SIRINA+2*DUGME_IZMEDJU)); break;
  case INTERFACE:
    FJezik[Jezik].Napisi(ekran,deffont,Crna,Bg,Interface,10,10,DUGME_POC_X-(DUGME_SIRINA+2*DUGME_IZMEDJU)); break;
  }
}

void NapisiBroj(int broj,int x_poc, int y_poc, int x_kraj){
  char br[20];

  sprintf(br,"%d",broj);
  FJezik[Jezik].Napisi(ekran, deffont, Crna, Bg, br, x_poc, y_poc, x_kraj);
}

void NacrtajSve(){

  SurfLock(ekran);

  // celo u zeleno
  SDL_FillRect( ekran, NULL, SDL_MapRGB(ekran->format,BgR,BgG,BgB) );
  // dugmici
  CrtajDugmice();

  if (StanjeHelp) {
    IspisiHelp(tHelp[Jezik],tRules[Jezik],tHouseWay[Jezik],tInterface[Jezik]);
  } else { // ako nije help{

    // zastave
    CrtajZastave();

    switch (StanjeIgre){

    case BIRANJE_OD_7:
      CrtajKarte(ja,7,POC_X,POC_J_BY, 1, 1);
      CrtajKarte(dealer,7,POC_X,POC_D_BY, 0, VARANJE);
      break;

    case REZULTAT:
      // back
      CrtajKarte(ja,5,POC_BX,POC_J_BY, 0, 1);
      CrtajKarte(dealer,5,POC_BX,POC_D_BY, 0, 1);
      // front
      CrtajKarte(ja+5,2,POC_FX,POC_J_FY, 0, 1);
      CrtajKarte(dealer+5,2,POC_FX,POC_D_FY, 0, 1);

      // pobednik
      FJezik[Jezik].Napisi(ekran,deffont,Crna,Bg,Rezultat[Jezik][Pobednik],ULOG_X+SIRINA_ZETONA+5*IZMEDJU_ZETONA+20,ULOG_Y-13,SIRINA_EKRANA);

      break;

    case KRAJIGRE:
      FJezik[Jezik].Napisi(ekran,deffont,Crna,Bg,tEnd[Jezik],100,100,SIRINA_EKRANA);
      break;

    }

    CrtajZetone();
    CrtajUlog();
    NapisiBroj(Ulog,ULOG_X+12,ULOG_Y+VISINA_ZETONA+2*IZMEDJU_ZETONA,SIRINA_EKRANA);
    NapisiBroj(Pare,ZETONI_X+7,ZETONI_Y+4*VISINA_ZETONA+6*IZMEDJU_ZETONA,SIRINA_EKRANA);


  } // }ako nije help


  SDL_Flip(ekran);
  SurfUnLock(ekran);
}

char bojauch(int boja){
  switch (boja){
  case 1: return 'h';
  case 2: return 'c';
  case 3: return 'd';
  case 4: return 's';
  }
  return 'h'; // da nema warning
}

void UcitajSveSlike(char Data_dir[]){
  int boja,vred,i;
  char b, imefajla[100];

  // dugme
  sprintf(imefajla,"%sDugme/dugme.bmp",Data_dir);
  dugme=SDL_LoadBMP(imefajla);
  for (i=0;i<BRJEZ;i++){
    dHelp[i]=SDL_LoadBMP(imefajla);
    dNext[i]=SDL_LoadBMP(imefajla);
    dHouseWay[i]=SDL_LoadBMP(imefajla);
    dInterface[i]=SDL_LoadBMP(imefajla);
    dRules[i]=SDL_LoadBMP(imefajla);
  }

  // zastave
  sprintf(imefajla,"%sDugme/zastava-srpski.bmp",Data_dir);
  zastava[SRPSKI]=SDL_LoadBMP(imefajla);
  sprintf(imefajla,"%sDugme/zastava-english.bmp",Data_dir);
  zastava[ENGLISH]=SDL_LoadBMP(imefajla);


  // zetoni
  sprintf(imefajla,"%sZetoni/1.bmp",Data_dir);
  zeton1=SDL_LoadBMP(imefajla);
  SDL_SetColorKey(zeton1, SDL_SRCCOLORKEY,SDL_MapRGB(zeton1->format,BgR,BgG,BgB));
  sprintf(imefajla,"%sZetoni/5.bmp",Data_dir);
  zeton5=SDL_LoadBMP(imefajla);
  SDL_SetColorKey(zeton5, SDL_SRCCOLORKEY,SDL_MapRGB(zeton5->format,BgR,BgG,BgB));
  sprintf(imefajla,"%sZetoni/25.bmp",Data_dir);
  zeton25=SDL_LoadBMP(imefajla);
  SDL_SetColorKey(zeton25, SDL_SRCCOLORKEY,SDL_MapRGB(zeton25->format,BgR,BgG,BgB));
  sprintf(imefajla,"%sZetoni/100.bmp",Data_dir);
  zeton100=SDL_LoadBMP(imefajla);
  SDL_SetColorKey(zeton100, SDL_SRCCOLORKEY,SDL_MapRGB(zeton100->format,BgR,BgG,BgB));

  // karte
  sprintf(imefajla,"%sKarte/b.bmp",Data_dir);
  zadnja_strana=SDL_LoadBMP(imefajla);

  sprintf(imefajla,"%sKarte/j.bmp",Data_dir);
  for (vred=1;vred<=14;vred++) // dzoker za svaku vrednost jer moguce
    karta[0][vred-1]=SDL_LoadBMP(imefajla); // da je promenjena

  for (boja=1;boja<=4;boja++){
    b=bojauch(boja);
    for (vred=2;vred<=9;vred++){
      sprintf(imefajla,"%sKarte/%d%c.bmp",Data_dir,vred,b);
      karta[boja][vred-1]=SDL_LoadBMP(imefajla);
    }
    sprintf(imefajla,"%sKarte/a%c.bmp",Data_dir,b);
    karta[boja][ 1-1]=SDL_LoadBMP(imefajla);
    karta[boja][14-1]=SDL_LoadBMP(imefajla);
    sprintf(imefajla,"%sKarte/k%c.bmp",Data_dir,b);
    karta[boja][13-1]=SDL_LoadBMP(imefajla);
    sprintf(imefajla,"%sKarte/q%c.bmp",Data_dir,b);
    karta[boja][12-1]=SDL_LoadBMP(imefajla);
    sprintf(imefajla,"%sKarte/j%c.bmp",Data_dir,b);
    karta[boja][11-1]=SDL_LoadBMP(imefajla);
    sprintf(imefajla,"%sKarte/t%c.bmp",Data_dir,b);
    karta[boja][10-1]=SDL_LoadBMP(imefajla);
  }
}

void OslobodiSveSlike(){
  int boja,vred,i;

  // dugme
  SDL_FreeSurface(dugme);
  for (i=0;i<BRJEZ;i++){
    SDL_FreeSurface(dHelp[i]);  SDL_FreeSurface(dNext[i]);
    SDL_FreeSurface(dHouseWay[i]);  SDL_FreeSurface(dInterface[i]);
    SDL_FreeSurface(dRules[i]);
  }

  // zastave
  SDL_FreeSurface(zastava[SRPSKI]);  SDL_FreeSurface(zastava[ENGLISH]);

  // zetoni
  SDL_FreeSurface(zeton1);  SDL_FreeSurface(zeton5);
  SDL_FreeSurface(zeton25);  SDL_FreeSurface(zeton100);

  // karte
  SDL_FreeSurface(zadnja_strana);

  for (boja=0;boja<=4;boja++)
    for (vred=1;vred<=14;vred++) SDL_FreeSurface(karta[boja][vred-1]);
  
}

void UcitajSveFontove(char Data_dir[]){
  char Font_path[100];
  sprintf(Font_path,"%sFont/FreeSans.ttf",Data_dir);
  deffont=TTF_OpenFont(Font_path,17);
}

void OslobodiSveFontove(){
  TTF_CloseFont(deffont);
}

void UcitajText(char path[], char koj[], char Text[]){
  int i,j;
  char t[100];
  FILE *f;

  Text[0]=0;

  sprintf(t,"%s%s.txt",path,koj);
  f=fopen(t,"r");
  t[0]='1';
  while (t[0]){
    t[0]=0;
    fscanf(f,"%s",t);
    if (Text[0]==0) sprintf(Text,"%s ",t); else sprintf(Text,"%s%s ",Text,t);
  }

  j=0;
  for (i=0;Text[i];i++){
    if (Text[i]=='|') {Text[j]='\n';if (Text[i+1]!='|') i++;} else Text[j]=Text[i];
    j++;
  }
  Text[j]=0;

  for (i=j+1;i<M;i++) Text[i]=0;

  //  cout<<Text<<endl;

  fclose(f);
}

void UcitajSveTekstove(char Data_dir[], char path[],char path2[],char dHelp[],char dNext[], char dHouseWay[], char dRules[], char dInterface[], char Help[], char Rules[],char HouseWay[],char Interface[],char End[]){
  
  char tpath[500];

  sprintf(tpath,"%s%s",Data_dir,path);

  UcitajText(tpath,"help",Help);
  UcitajText(tpath,"houseway",HouseWay);
  UcitajText(tpath,"interface",Interface);
  UcitajText(tpath,"rules",Rules);
  UcitajText(tpath,"end",End);

  sprintf(tpath,"%s%s",Data_dir,path2);

  UcitajText(tpath,"help",dHelp);
  UcitajText(tpath,"next",dNext);
  UcitajText(tpath,"houseway",dHouseWay);
  UcitajText(tpath,"interface",dInterface);
  UcitajText(tpath,"rules",dRules);

}

void PodeliKarte(Karta ruka[], int Vec[]){
  int i,t;
  double r;

  for (i=0;i<7;i++){

    do{
      r=double(rand());
      t=int(53*r/RAND_MAX); // Verovatno ok, ali nije sigurno...
    } while (Vec[t]); // dok ne nadjem nepodeljenu tako da nema 2 keca pik
    Vec[t]=1;

    if (t==0) {ruka[i].vred=0;ruka[i].boja=0;} else
      {
	ruka[i].vred=(t-1)/4+2;
	ruka[i].boja=t%4+1;
      }
  }
  sortRuku(ruka,7);
}

void NovoDeljenje(){
  int i,Vec[53];

  for (i=0;i<53;i++) Vec[i]=0;
  PodeliKarte(ja,Vec);
  PodeliKarte(dealer,Vec);

  /* Za testiranje, po jedan dzoker svakome
  if (ja[6].vred!=0) {ja[0].vred=0; ja[0].boja=0;}
  if (dealer[6].vred!=0) {dealer[0].vred=0; dealer[0].boja=0;}
  */
  /* Nije radilo jer KEC nije nikad proban kao 1 u dealer.cpp
  ja[0].vred=14; ja[1].vred=8;ja[2].vred=5;ja[3].vred=4;ja[4].vred=3;
  ja[5].vred=2;ja[6].vred=2;
  ja[0].boja=2;ja[1].boja=4;ja[2].boja=1;ja[3].boja=2;ja[4].boja=2;
  ja[5].boja=2;ja[6].boja=3;
  */
  

  
  sortRuku(ja,7); sortRuku(dealer,7);
   
  

  if (DEBUG) {
    for (i=0;i<7;i++) cout<<ja[i].vred<<"_"<<ja[i].boja<<"  "; cout<<"\n";
    for (i=0;i<7;i++) cout<<dealer[i].vred<<"_"<<dealer[i].boja<<"  "; cout<<"\n\n";
  }

  for (i=0;i<7;i++) KartaIzabrana[i]=0;

  if (DEBUG) cout<<Pare<<endl;

  // NIKAKO!!   StanjeIgre=STAVLJANJE_ULOGA;
}

void PobedioJa(){
  Pare+=95*Ulog/100; // ne jos +Ulog jer ga vec ostavljam na stolu
  Pobednik=JA;
  if (DEBUG) cout<<"Ja\n";
}
void PobedioDealer(){
  Pare-=Ulog;
  if (Pare<0) {Ulog+=Pare; Pare=0;} // za sledecu rundu
  Pobednik=DEALER;
  if (DEBUG) cout<<"Dealer\n";
}
void PobedioNiko(){
  Pobednik=NERESENO;
  if (DEBUG) cout<<"Nereseno\n";
}

void NovaIgra(){
  Pare=POCETNE_PARE;
  Ulog=25;
  Pare-=Ulog;
  NovoDeljenje();
  StanjeIgre=STAVLJANJE_ULOGA;
}




int UPravougaoniku(int x, int y,
		   int levogore_x, int levogore_y,
		   int desnodole_x, int desnodole_y){
  if (x<levogore_x || x>desnodole_x) return 0;
  if (y<levogore_y || y>desnodole_y) return 0;
  return 1;
}


void DaLiKlikNaZastave(int mx, int my){
  if (UPravougaoniku(mx,my,ZASTAVA_X,ZASTAVA_Y,ZASTAVA_X+ZASTAVA_SIRINA,ZASTAVA_Y+ZASTAVA_VISINA)) Jezik=SRPSKI; else
    if (UPravougaoniku(mx,my,ZASTAVA_X,ZASTAVA_Y+ZASTAVA_VISINA+ZASTAVA_IZMEDJU,ZASTAVA_X+ZASTAVA_SIRINA,ZASTAVA_Y+2*ZASTAVA_VISINA+ZASTAVA_IZMEDJU)) Jezik=ENGLISH;
}

void DaLiKlikNaKarte(int mx, int my){
  int x=POC_X, y=POC_J_BY, w=SIRINA_KARTE, h=VISINA_KARTE;
  int dX=IZMEDJU_KARATA, dY=DELTA_Y;
  int i;

  for (i=0;i<7 && !UPravougaoniku(mx,my,
				  x , y-dY*KartaIzabrana[i] ,
				  x+w , y+h-dY*KartaIzabrana[i])
	 ;i++)
    x+=w+dX;
  if (i<7) KartaIzabrana[i]=1-KartaIzabrana[i];
}

int IzabraneTacno2Karte(){
  int i,br=0;
  for (i=0;i<7;i++) br+=KartaIzabrana[i];
  if (br==2) return 1;
  return 0;
}
int DobroIzabrane(){ // da li napred losije od nazad
  Karta t[7];
  int i,b=0;
  for (i=0;i<7;i++) if (KartaIzabrana[i]) t[5+b++]=ja[i]; else t[i-b]=ja[i];
  if (Uporedi2saRukom(t+5,t)!=1) return 1;
  return 0;
}

void OdrediPobednika(){
  Karta t[7];
  int i,b=0;
  int PobedaNapred,PobedaNazad;

  HouseWay(dealer);

  for (i=0;i<7;i++) if (KartaIzabrana[i]) t[5+b++]=ja[i]; else t[i-b]=ja[i];
  for (i=0;i<7;i++) ja[i]=t[i];

  PobedaNazad=UporediRuke(ja,dealer);
  PobedaNapred=Uporedi2sa2(ja+5,dealer+5);
  
  if (PobedaNapred==1 && PobedaNazad==1)
    PobedioJa(); else
    if (PobedaNazad==1 || PobedaNapred==1) PobedioNiko();
    else PobedioDealer();
}

void IzaberiKarteHouseWay(){
  Karta t[7];
  int i,j;

  for (i=0;i<7;i++) t[i]=ja[i];
  HouseWay(t);

  for (i=0;i<7;i++) KartaIzabrana[i]=0;
  
  for (j=5;j<7;j++){
    for (i=0;i<7;i++)
      if (ja[i].boja==t[j].boja && ( ja[i].boja==0 || ja[i].vred==t[j].vred ))
	KartaIzabrana[i]=1;
  }
  
}

void Dalje(){

  switch (StanjeIgre){

  case STAVLJANJE_ULOGA:
    if (Ulog>0){
      StanjeIgre=BIRANJE_OD_7;
      NovoDeljenje();
    }
    break;

  case BIRANJE_OD_7:
    if ( IzabraneTacno2Karte() && DobroIzabrane() ){
      StanjeIgre=REZULTAT;
      OdrediPobednika();
    }
    break;

  case REZULTAT:
    if (Pare==0 && Ulog==0)
      StanjeIgre=KRAJIGRE;
    else StanjeIgre=STAVLJANJE_ULOGA;
    break;

  case KRAJIGRE:
    NovaIgra();
    break;

  }


}

void DaLiKlikNaDugmad(int mx, int my){
  int x=DUGME_POC_X, y=DUGME_POC_Y, w=DUGME_SIRINA, h=DUGME_VISINA, d=DUGME_IZMEDJU;
  if (UPravougaoniku(mx,my, x , y , x+w , y+h )) {
    if (StanjeHelp) StanjeHelp=0; else StanjeHelp=HELP;
  }

  if (UPravougaoniku(mx,my, x, y+2*(h+d) , x+w , y+2*(h+d)+h )) Dalje();


  if (StanjeIgre == BIRANJE_OD_7 && UPravougaoniku(mx,my, x, y+3*(h+d) , x+w , y+3*(h+d)+h )) IzaberiKarteHouseWay();

  if (StanjeHelp){
    x-=w+2*d;
    if (UPravougaoniku(mx,my, x , y , x+w , y+h )) StanjeHelp=RULES;
    if (UPravougaoniku(mx,my, x, y+1*(h+d) , x+w , y+1*(h+d)+h )) StanjeHelp=HOUSEWAY;
    if (UPravougaoniku(mx,my, x, y+2*(h+d) , x+w , y+2*(h+d)+h )) StanjeHelp=INTERFACE;
  }
}

void PovecajUlog(int za){
  int tUlog=Ulog;
  Ulog+=za;

  if (Ulog<0) Ulog=0;
  if (Ulog>MAXULOG) Ulog=MAXULOG;
  if (Ulog-tUlog>Pare) Ulog=Pare+tUlog;

  Pare-=Ulog-tUlog;
  // ne treba
  if (DEBUG && Ulog!=tUlog) cout<<Pare<<endl;
}

void DaLiKlikNaUlog(int delta, int mx, int my){
  int x=ZETONI_X,y=ZETONI_Y,w=SIRINA_ZETONA,h=VISINA_ZETONA;

  if (UPravougaoniku(mx,my, x , y , x+w , y+h)) PovecajUlog(delta*100);
  y+=h+IZMEDJU_ZETONA;
  if (UPravougaoniku(mx,my, x , y , x+w , y+h)) PovecajUlog(delta*25);
  y+=h+IZMEDJU_ZETONA;
  if (UPravougaoniku(mx,my, x , y , x+w , y+h)) PovecajUlog(delta*5);
  y+=h+IZMEDJU_ZETONA;
  if (UPravougaoniku(mx,my, x , y , x+w , y+h))  PovecajUlog(delta*1);

}

// VAZNO: Lock
void NapraviDugmice(){
  int i;
  for(i=0;i<BRJEZ;i++){
    FJezik[i].Napisi(dHelp[i],deffont,Crna,Bg,tdHelp[i],30,5,DUGME_SIRINA);
    FJezik[i].Napisi(dNext[i],deffont,Crna,Bg,tdNext[i],32,5,DUGME_SIRINA);
    FJezik[i].Napisi(dHouseWay[i],deffont,Crna,Bg,tdHouseWay[i],11,5,DUGME_SIRINA);
    FJezik[i].Napisi(dRules[i],deffont,Crna,Bg,tdRules[i],17,5,DUGME_SIRINA);
    FJezik[i].Napisi(dInterface[i],deffont,Crna,Bg,tdInterface[i],17,5,DUGME_SIRINA);
  }

}

void GPL(){
  cout<<"\n";
  cout<<"\tRA Pai Gaw Poker version 1.0, Copyright (C) 2004 Relja Arandjelovic\n";
  cout<<"\tRA Pai Gaw Poker comes with ABSOLUTELY NO WARRANTY;\n";
  cout<<"\tThis is free software, and you are welcome\n";
  cout<<"\tto redistribute it under certain conditions;\n";
  cout<<"\tSee COPYING for details.\n\n";
}

int main(){
  //  int mis_odlaganje_L=0,d_mis_odlaganje_L=0;
  //  int mis_odlaganje_R=0,d_mis_odlaganje_R=0;
  //  int mis_odlaganje_GRANICA=10;
  int TrebaDaCrta=1; // prvi put
  int mx=0,my=0;
  char Data_dir[500];
  data_dir(Data_dir);
  
  GPL();

  opcije_ucitaj(Jezik);
  
  FJezik[SRPSKI].Inicijalizuj(Data_dir,"srpski");
  FJezik[ENGLISH].Inicijalizuj(Data_dir,"english");

  // init SDL{

  if(SDL_Init(SDL_INIT_VIDEO) < 0)
  {
    cout<<"SDL: Neuspesna SDL inicijalizacija: "<< SDL_GetError()<<endl;
    exit(1);
  }
  atexit(SDL_Quit);

  ekran=SDL_SetVideoMode(SIRINA_EKRANA,VISINA_EKRANA,32,
			 SDL_HWSURFACE|SDL_DOUBLEBUF);
  if ( ekran == NULL )
    {
      cout<<"SDL: Neuspesno postavljanje 800x600: "<< SDL_GetError()<<endl;
      exit(1);
    }

  SDL_WM_SetCaption("Pai Gaw Poker - Relja Arandjelovic",
		    "Pai Gaw Poker - Relja Arandjelovic");

  UcitajSveSlike(Data_dir);
  // }init SDL

  TTF_Init(); atexit(TTF_Quit);
  UcitajSveFontove(Data_dir);


  // VAZNO: opet isto
  UcitajSveTekstove(Data_dir,"Help/Srpski/","Dugme/Srpski/",tdHelp[SRPSKI],tdNext[SRPSKI],tdHouseWay[SRPSKI],tdRules[SRPSKI],tdInterface[SRPSKI],tHelp[SRPSKI],tRules[SRPSKI],tHouseWay[SRPSKI],tInterface[SRPSKI],tEnd[SRPSKI]);
  UcitajSveTekstove(Data_dir,"Help/English/","Dugme/English/",tdHelp[ENGLISH],tdNext[ENGLISH],tdHouseWay[ENGLISH],tdRules[ENGLISH],tdInterface[ENGLISH],tHelp[ENGLISH],tRules[ENGLISH],tHouseWay[ENGLISH],tInterface[ENGLISH],tEnd[ENGLISH]);
  NapraviDugmice();
  InicijalizujTekstRezultat();


  // inicijalizuj random
  srand(time(NULL));



  NovaIgra();


  while (KRAJ==0){
    SDL_Event dogadjaj;

    //    while (SDL_PollEvent(&dogadjaj)){
    SDL_WaitEvent(&dogadjaj);

    if ( dogadjaj.type==SDL_QUIT ) KRAJ=1;
    if ( dogadjaj.type==SDL_KEYDOWN ) {
      if ( dogadjaj.key.keysym.sym==SDLK_ESCAPE ) KRAJ=1; // izlaz

      if ( StanjeHelp==0 && dogadjaj.key.keysym.sym==SDLK_RETURN ) // dalje
	{Dalje(); TrebaDaCrta=1;}

      if ( StanjeIgre==BIRANJE_OD_7 && dogadjaj.key.keysym.sym==SDLK_SPACE )
	{IzaberiKarteHouseWay(); TrebaDaCrta=1;} // HouseWay

      if ( StanjeIgre==BIRANJE_OD_7 ){ // brojevi za karte
	if (dogadjaj.key.keysym.sym==SDLK_1)
	  {KartaIzabrana[0]=1-KartaIzabrana[0]; TrebaDaCrta=1;} else
	if (dogadjaj.key.keysym.sym==SDLK_2)
	  {KartaIzabrana[1]=1-KartaIzabrana[1]; TrebaDaCrta=1;} else
	if (dogadjaj.key.keysym.sym==SDLK_3)
	  {KartaIzabrana[2]=1-KartaIzabrana[2]; TrebaDaCrta=1;} else
	if (dogadjaj.key.keysym.sym==SDLK_4)
	  {KartaIzabrana[3]=1-KartaIzabrana[3]; TrebaDaCrta=1;} else
	if (dogadjaj.key.keysym.sym==SDLK_5)
	  {KartaIzabrana[4]=1-KartaIzabrana[4]; TrebaDaCrta=1;} else
	if (dogadjaj.key.keysym.sym==SDLK_6)
	  {KartaIzabrana[5]=1-KartaIzabrana[5]; TrebaDaCrta=1;} else
	if (dogadjaj.key.keysym.sym==SDLK_7)
	  {KartaIzabrana[6]=1-KartaIzabrana[6]; TrebaDaCrta=1;}
      }

      if ( StanjeIgre==STAVLJANJE_ULOGA ) { // ulog
	if (dogadjaj.key.keysym.sym==SDLK_d)
	  {PovecajUlog(1); TrebaDaCrta=1;} else
	if (dogadjaj.key.keysym.sym==SDLK_f)
	  {PovecajUlog(5); TrebaDaCrta=1;} else
	if (dogadjaj.key.keysym.sym==SDLK_g)
	  {PovecajUlog(25); TrebaDaCrta=1;} else
	if (dogadjaj.key.keysym.sym==SDLK_h)
	  {PovecajUlog(100); TrebaDaCrta=1;} else
	if (dogadjaj.key.keysym.sym==SDLK_c)
	  {PovecajUlog(-1); TrebaDaCrta=1;} else
	if (dogadjaj.key.keysym.sym==SDLK_v)
	  {PovecajUlog(-5); TrebaDaCrta=1;} else
	if (dogadjaj.key.keysym.sym==SDLK_b)
	  {PovecajUlog(-25); TrebaDaCrta=1;} else
	if (dogadjaj.key.keysym.sym==SDLK_n)
	  {PovecajUlog(-100); TrebaDaCrta=1;}
      }

    }
      //    }


    // mis{
    if (SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(1)){
      TrebaDaCrta=1;

      SDL_GetMouseState(&mx,&my);

      // cout<<"Levo dugme misa: "<<mx<<" "<<my<<endl;
      // DaLiKlikNaKraj
      if (StanjeHelp==0) DaLiKlikNaZastave(mx,my);

      switch (StanjeIgre){
      case STAVLJANJE_ULOGA:
	if (StanjeHelp==0) DaLiKlikNaUlog(1,mx,my); //1 povecanje
	DaLiKlikNaDugmad(mx,my);
	break;
      case BIRANJE_OD_7:
	if (StanjeHelp==0) DaLiKlikNaKarte(mx,my);
	DaLiKlikNaDugmad(mx,my);
	break;
      case REZULTAT: case KRAJIGRE:
	Dalje();
	break;
      }
    } // }levo dugme

    if (SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(3)){
      TrebaDaCrta=1;

      SDL_GetMouseState(&mx,&my);

      // cout<<"Desno dugme misa: "<<mx<<" "<<my<<endl;
      if (StanjeHelp==0) DaLiKlikNaZastave(mx,my);

      switch (StanjeIgre){
      case STAVLJANJE_ULOGA:
	if (StanjeHelp==0) DaLiKlikNaUlog(-1,mx,my); //-1 smanjuje
	DaLiKlikNaDugmad(mx,my);
	break;
      case BIRANJE_OD_7:
	if (StanjeHelp==0) DaLiKlikNaKarte(mx,my);
	DaLiKlikNaDugmad(mx,my);
	break;
      case REZULTAT: case KRAJIGRE:
	Dalje();
	break;
      }
    } // }desno dugme

    // }mis


    // Najzad nacrtaj sve
    if (TrebaDaCrta) NacrtajSve();
    TrebaDaCrta=0;
  }

  GPL();

  OslobodiSveSlike();
  OslobodiSveFontove();

  opcije_sacuvaj(Jezik);

  return 0;
}
