 /*
Copyright (C) 2004 Relja Arandjelovic, see COPYING

    This file is part of RA Pai Gaw Poker.

    RA Pai Gaw Poker is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


//#ifdef HAVE_CONFIG_H
//#include <config.h>
//#endif

//#include <iostream.h>
//#include <fstream.h>
// moram ovo pregledno sa onim da li vec ukljuceno
//#include "poker.h"

// za sprintf
#include <stdio.h>
//#include <stdlib.h> // nisam siguran da li potrebno za random
// za random
#include <time.h>

#include <SDL.h>
#include <SDL_ttf.h>

#include "dealer.h"
#include "sdl_obicno.h"
#include "font.h"
#include "dirovi.h"


const int BgR=39, BgG=102, BgB=43;
SDL_Color Bg={BgR,BgG,BgB,0};
SDL_Color Crna={0,0,0,0};

const int DEBUG=0;
const int SIRINA_EKRANA=800, VISINA_EKRANA=600;

const int IZMEDJU_KARATA=5, SIRINA_KARTE=73, VISINA_KARTE=97;
const int POC_X=150;
const int POC_BX=POC_X+SIRINA_KARTE+IZMEDJU_KARATA;
const int POC_FX=(7*SIRINA_KARTE+6*IZMEDJU_KARATA)/2+POC_X
  -(IZMEDJU_KARATA/2+SIRINA_KARTE);
const int DELTA_Y=VISINA_KARTE/2; // koliko uzdignuti izabranu kartu
const int POC_J_BY=VISINA_EKRANA-VISINA_KARTE-30;
const int POC_J_FY=POC_J_BY-(VISINA_KARTE+IZMEDJU_KARATA);
const int POC_D_BY=30;
const int POC_D_FY=POC_D_BY+VISINA_KARTE+IZMEDJU_KARATA;

const int IZMEDJU_ZETONA=5, VISINA_ZETONA=55, SIRINA_ZETONA=55, DEBLJINA_ZETONA=10;
const int ZETONI_X=10;
const int ZETONI_Y=VISINA_EKRANA/2 - (2*VISINA_ZETONA + 3*IZMEDJU_ZETONA/2);
const int ULOG_X=SIRINA_EKRANA/2-108, ULOG_Y=VISINA_EKRANA/2;

const int DUGME_SIRINA=131, DUGME_VISINA=37, DUGME_IZMEDJU=10;
const int DUGME_POC_X=SIRINA_EKRANA-DUGME_SIRINA-DUGME_IZMEDJU;
const int DUGME_POC_Y=POC_D_BY+VISINA_KARTE+30;

const int ZASTAVA_X=ZETONI_X, ZASTAVA_Y=POC_D_BY;
const int ZASTAVA_VISINA=36, ZASTAVA_SIRINA=64, ZASTAVA_IZMEDJU=5;

const int SRPSKI=0, ENGLISH=1, BRJEZ=2;

const int M=3000;
char tdHelp[BRJEZ][M],tdNext[BRJEZ][M],tdHouseWay[BRJEZ][M],tdRules[BRJEZ][M],tdInterface[BRJEZ][M],tHelp[BRJEZ][M],tRules[BRJEZ][M],tHouseWay[BRJEZ][M],tInterface[BRJEZ][M],tEnd[BRJEZ][M];
const int HELP=1, RULES=2, HOUSEWAY=3, INTERFACE=4;

char Rezultat[BRJEZ][3][30];

SDL_Surface *ekran;
SDL_Surface *zadnja_strana,*karta[5][14]; //boja, vred-1 jer Kec=1 moguce
SDL_Surface *zeton1,*zeton5,*zeton25,*zeton100;
SDL_Surface *dugme,*dHelp[BRJEZ],*dNext[BRJEZ],*dHouseWay[BRJEZ],*dInterface[BRJEZ],*dRules[BRJEZ];
SDL_Surface *zastava[BRJEZ];

Font FJezik[BRJEZ];
TTF_Font *deffont;

Karta ja[7],dealer[7];
int KartaIzabrana[7];

int KRAJ=0;

int VARANJE=0;

const int STAVLJANJE_ULOGA=0, BIRANJE_OD_7=1, REZULTAT=2, KRAJIGRE=3;
const int POCETNE_PARE=500, MAXULOG=500;
const int NERESENO=0, JA=1, DEALER=2;

int StanjeIgre=STAVLJANJE_ULOGA;
int StanjeHelp=0;
int Jezik=SRPSKI;
int Ulog=0;
int Pare=POCETNE_PARE;
int Pobednik=NERESENO;
