/*
Copyright (C) 2004 Relja Arandjelovic, see COPYING

    This file is part of RA Pai Gaw Poker.

    RA Pai Gaw Poker is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "sdl_obicno.h"

//---------------------------------------------

void NacrtajSliku(SDL_Surface *slika, SDL_Surface *na, int nax, int nay)
{
  SDL_Rect dest;
  dest.x = nax;
  dest.y = nay;
  SDL_BlitSurface(slika, NULL, na, &dest);
}

void NacrtajDeoSlike(SDL_Surface *slika, int x, int y, int w, int h, int nax, int nay, SDL_Surface *na)
{
  SDL_Rect dest;
  dest.x = nax;
  dest.y = nay;
  SDL_Rect deoslike;
  deoslike.x = x;
  deoslike.y = y;
  deoslike.w = w;
  deoslike.h = h;
  SDL_BlitSurface(slika, &deoslike, na, &dest);
}


//---------------------------------------------


void SurfLock(SDL_Surface *na)
{
  if ( SDL_MUSTLOCK(na) )
  {
    if ( SDL_LockSurface(na) < 0 )
    {
      return;
    }
  }
}

void SurfUnLock(SDL_Surface *na)
{
  if ( SDL_MUSTLOCK(na) )
  {
    SDL_UnlockSurface(na);
  }
}
